routes/web.php
<?php


/* --------------------- Common/User Routes START -------------------------------- */

Route::get('/', function () {
    // return view('welcome');
    return redirect('admin/dashboard');
});

Auth::routes(['verify' => true]);

Route::get('/home', 'HomeController@index')->name('home')->middleware('verified');

/* --------------------- Common/User Routes END -------------------------------- */

/* ----------------------- Admin Routes START -------------------------------- */

Route::prefix('/admin')->name('admin.')->namespace('Admin')->group(function () {

    /**
     * Admin Auth Route(s)
     */
    Route::namespace('Auth')->group(function () {

        //Login Routes
        Route::get('/login', 'LoginController@showLoginForm')->name('login');
        Route::post('/login', 'LoginController@login');
        Route::post('/logout', 'LoginController@logout')->name('logout');

        //Register Routes
        // Route::get('/register','RegisterController@showRegistrationForm')->name('register');
        // Route::post('/register','RegisterController@register');

        //Forgot Password Routes
        Route::get('/password/reset', 'ForgotPasswordController@showLinkRequestForm')->name('password.request');
        Route::post('/password/email', 'ForgotPasswordController@sendResetLinkEmail')->name('password.email');

        //Reset Password Routes
        Route::get('/password/reset/{token}', 'ResetPasswordController@showResetForm')->name('password.reset');
        Route::post('/password/reset', 'ResetPasswordController@reset')->name('password.update');

        // Email Verification Route(s)
        Route::get('email/verify', 'VerificationController@show')->name('verification.notice');
        Route::get('email/verify/{id}', 'VerificationController@verify')->name('verification.verify');
        Route::get('email/resend', 'VerificationController@resend')->name('verification.resend');
    });

    Route::get('/dashboard', 'HomeController@index')->name('home');
    Route::get('/settings', 'HomeController@settings')->name('settings');
    Route::post('/updateSettings', 'HomeController@updateSettings')->name('updateSettings');

    // User Management
    Route::get('/users', 'UserController@index')->name('user');
    Route::get('/getUserListings', 'UserController@getUserListings')->name('getUserListings');
    Route::get('/user/{id}', 'UserController@show')->name('user.show');
    Route::get('/user/{id}/edit', 'UserController@edit')->name('user.edit');
    Route::post('/user/{id}/edit', 'UserController@doEdit')->name('user.do-edit');
    Route::get('/user/{id}/delete', 'UserController@delete')->name('user.delete');

    // NPO Management
    Route::get('/npo-listings', 'NPOController@index')->name('npo');
    Route::get('/getNPOListings', 'NPOController@getNPOListings')->name('getNPOListings');
    Route::get('/add-npo', 'NPOController@add')->name('npo.add');
    Route::post('/addNpo', 'NPOController@addNpo')->name('npo.do-addNpo');
    Route::get('/npo/{id}', 'NPOController@show')->name('npo.show');
    Route::get('/npo/{id}/edit', 'NPOController@edit')->name('npo.edit');
    Route::post('/npo/{id}/edit', 'NPOController@doEdit')->name('npo.do-edit');
    Route::get('/npo/{id}/delete', 'NPOController@delete')->name('npo.delete');

    // NPO Categories
    Route::get('/npo-categories', 'NpoCategoriesController@index')->name('npocategories');
    Route::get('/getNPOCategoryListings', 'NpoCategoriesController@getNPOCategoryListings')->name('getNPOCategoryListings');
    Route::get('/add-npo-category', 'NpoCategoriesController@create')->name('npocategories.add-npo-category');
    Route::post('/createNpoCategory', 'NpoCategoriesController@createNpoCategory')->name('createNpoCategory');
    Route::get('/npo-categories/{id}/edit', 'NpoCategoriesController@edit')->name('npocategories.edit-npo-category');
    Route::post('/npo-categories/{id}/edit', 'NpoCategoriesController@updateNpoCategory')->name('updateNpoCategory');


    // NPO Coupons
    Route::get('/coupons', 'CouponController@index')->name('coupons');
    Route::get('/getCouponListings', 'CouponController@getCouponListings')->name('getCouponListings');
    Route::get('/add-coupon', 'CouponController@create')->name('coupons.add-coupon');
    Route::post('/createCoupon', 'CouponController@createCoupon')->name('createCoupon');
    Route::get('/coupons/{id}/edit', 'CouponController@edit')->name('coupons.edit-coupon');
    Route::post('/coupons/{id}/edit', 'CouponController@updateCoupon')->name('updateCoupon');   

    // Giveaways
    Route::get('/giveaways', 'GiveawaysController@index')->name('giveaways');
    Route::get('/getGiveawaysListings', 'GiveawaysController@getGiveawaysListings')->name('getGiveawaysListings');
    Route::get('/add-giveaway', 'GiveawaysController@create')->name('giveaways.add-giveaway');
    Route::post('/createGiveaway', 'GiveawaysController@createGiveaway')->name('createGiveaway');
    Route::get('/giveaways/{id}/edit', 'GiveawaysController@edit')->name('giveaways.edit-giveaway');
    Route::post('/giveaways/{id}/edit', 'GiveawaysController@updateGiveaway')->name('updateGiveaway'); 


    // Champions
    Route::get('/champions', 'ChampionsController@index')->name('champions');
    Route::get('/getChampionsListings', 'ChampionsController@getChampionsListings')->name('getChampionsListings');
    Route::get('/add-champion', 'ChampionsController@create')->name('champions.add-champion');
    Route::post('/createChampion', 'ChampionsController@createChampion')->name('createChampion');
    Route::get('/champions/{id}/edit', 'ChampionsController@edit')->name('champions.edit-champion');
    Route::post('/champions/{id}/edit', 'ChampionsController@updateChampion')->name('updateChampion'); 


    //Put all of your admin routes here...

});

/* ----------------------- Admin Routes END -------------------------------- */

app/Http/Controllers/API/V1/UserController.php
<?php

namespace App\Http\Controllers\API\V1;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Validator;
use App\User;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Auth as FacadesAuth;
use Auth;
use Illuminate\Foundation\Auth\Allusers as Authenticatable;
use Laravel\Passport\PassportServiceProvider;
use Illuminate\Support\Str;
use Mail;

class UserController extends BaseController
{
    public function register(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'email' => ['required', 'email'],
            'password' => ['required', 'string', 'min:8', 'max:50']
        ]);

        if ($validator->fails()) {
            return $this->sendError('Validation Error.', $validator->errors());
        }
        $input = $request->all();
        $userExists = User::where('email', '=', $input['email'])->first();
        if (empty($userExists)) {

            
            $user = new User();
            $user->email = $request->email;
            $user->password = Hash::make($request->password);
            $user->name = "";
            $user->save();

            $input = $request->all();
            Auth::attempt($input);
            $user = Auth::user();
            $success['accountType'] = $user->user_role;
            $success['response'] = Config('constants.SUCCESSFULLY_REGISTERED');
            $token = $user->createToken('MyApp')->accessToken;
            return response()->json($success, 200)->header('x-auth-token', $token);
        } else {

            $error['response'] = Config('constants.USER_ALREADY_EXIST');
            return response()->json($error, 401);
        }
    }
    public function login(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'email' => ['required', 'email'],
            'password' => ['required', 'string']
        ]);

        if ($validator->fails()) {
            return $this->sendError('Validation Error.', $validator->errors());
        }
        $input = $request->all();

        if (Auth::attempt($input)) {

            $user = Auth::user();
            $success['accountType'] = $user->user_role;
            $success['response'] = Config('constants.LOGIN_SUCCESSFULL');
            $token = $user->createToken('MyApp')->accessToken;
            return response()->json($success, 200)->header('x-auth-token', $token);
        } else {
            $error['response'] = Config('constants.INVALID_USER_DETAILS');
            return response()->json($error, 401);
        }
    }
    public function forgotPassword(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'email' => 'required'
        ]);
        if ($validator->fails()) {
            return $this->sendError('Validation Error.', $validator->errors());
        }
        $input = $request->all();
        $userExists = User::where('email', '=', $input['email'])->first();
        if (!empty($userExists)) {
            $token = Str::random(60);

            $update_token['remember_token'] = $token;
            user::where('email', '=', $input['email'])->update($update_token);
            // $forgot_password_link = Config('constants.FORGOT_PASSWORD_LINK') . $token;
            $forgot_password_link = '13.239.180.63/tgc/#/user/reset-password?token='.$token;

            $data['token'] = $token;
            $data['email'] = $input['email'];
            $data['name'] = $userExists['name'];
            $data['forgot_password_link'] = $forgot_password_link;

            Mail::send('api.forgot_password_email', $data, function ($message) use ($data) {
                $message->from('no-reply@thegreatconnect.org', 'TGC');
                $message->to($data['email'], $data['name']);
                $message->subject('Forgot password!');
            });

            if (Mail::failures()) {
                $error['response'] = Config('constants.SOMETHING_WENT_WRONG');
                return response()->json($error, 401);
            } else {
                $success['response'] = Config('constants.EMAIL_SENT_SUCCESSFULLY');
                return response()->json($success, 200);
            }
        } else {
            $error['response'] = Config('constants.USER_NOT_FOUND');
            return response()->json($error, 401);
        }
    }
    public function logout(Request $request)
    {
        if (Auth::check()) {
            Auth::user()->token()->revoke();
            $success['response'] = Config('constants.LOGOUT_SUCCESSFULLY');;
            return response()->json($success, 200);
        } else {
            $error['response'] = Config('constants.INVALID_AUTH_TOKEN');
            return response()->json($error, 401);
        }
    }
    public function verifyAuthToken(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'verifyToken' => 'required'
        ]);
        if ($validator->fails()) {
            return $this->sendError('Validation Error.', $validator->errors());
        }
        $input = $request->all();
        $userInfo = User::where('remember_token', '=', $input['verifyToken'])->first();
        if (!empty($userInfo)) {
            $success['response'] = Config('constants.SUCCESS');
            $success['user_id'] = $userInfo['id'];

            $update_token['remember_token'] = "";
            User::where('id', '=', $userInfo['id'])->update($update_token);

            return response()->json($success, 200);
        } else {
            $error['response'] = Config('constants.TOKEN_EXPIRED');
            return response()->json($error, 401);
        }
    }
    public function resetPassword(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'user_id' => 'required',
            'password' => ['required', 'string', 'min:8', 'max:50']
        ]);
        if ($validator->fails()) {
            return $this->sendError('Validation Error.', $validator->errors());
        }
        $input = $request->all();
        $userInfo = User::where('id', '=', $input['user_id'])->first();
        if (!empty($userInfo)) {

            $update_data['password'] = Hash::make($input['password']);

            $response = USER::where('id', '=', $input['user_id'])->update($update_data);
            if ($response) {

                $data['email'] = $userInfo['email'];
                $data['name'] = $userInfo['name'];

                Mail::send('api.reset_password_success', $data, function ($message) use ($data) {
                    $message->from('no-reply@thegreatconnect.org', 'TGC');
                    $message->to($data['email'], $data['name']);
                    $message->subject('Password reset successfully!');
                });

                if (Mail::failures()) {
                    $error['response'] = Config('constants.SOMETHING_WENT_WRONG');
                    //return response()->json($error, 401);
                }

                $success['response'] = Config('constants.PASSWORD_RESET_SUCCESSFULLY');
                return response()->json($success, 200);
            } else {
                $error['response'] = Config('constants.SOMETHING_WENT_WRONG');
                return response()->json($error, 401);
            }
        } else {
            $error['response'] = Config('constants.USER_NOT_FOUND');
            return response()->json($error, 401);
        }
    }
    public function getUserDetails(Request $request){
        $userInfo = Auth::user();
        if(!empty($userInfo)){
            $success['response'] = Config('constants.SUCCESS');
            $success['user_details'] = $userInfo;
            return response()->json($success, 200);
        }else{
            $error['response'] = Config('constants.USER_NOT_FOUND');
            return response()->json($error, 401);
        }
    }
    public function updateUserProfile(Request $request){
        $input = $request->all();

        if(!empty($input['password'])){
            $validator = Validator::make($request->all(), [
                'first_name' => ['required', 'string'],
                'last_name' => ['required', 'string'],
                'name' => ['required', 'string'],
                'password' => ['required', 'string', 'min:8', 'max:50']
            ]);
        }else{
            $validator = Validator::make($request->all(), [
                'first_name' => ['required', 'string'],
                'last_name' => ['required', 'string'],
                'name' => ['required', 'string']
            ]);
        }
        if ($validator->fails()) {
            return $this->sendError('Validation Error.', $validator->errors());
        }
        $userInfo = Auth::user();

        $update_data['first_name'] = $input['first_name'];
        $update_data['last_name'] = $input['last_name'];
        $update_data['name'] = $input['name'];
        if(!empty($input['password'])){
            $update_data['password'] = Hash::make($input['password']);
        }
        $response = USER::where('id', '=', $userInfo->id)->update($update_data);
        if ($response) {
            $success['response'] = Config('constants.PROFILE_UPDATED_SUCCESSFULLY');
            return response()->json($success, 200);
        } else {
            $error['response'] = Config('constants.SOMETHING_WENT_WRONG');
            return response()->json($error, 401);
        }
    }
}

app/Http/Controllers/Admin/UserController.php
<?php

namespace App\Http\Controllers\Admin;

use Illuminate\Http\Request;
use App\Http\Requests\Admin\UpdateUserRequest;
use App\Http\Controllers\Controller;
use App\User;
use Yajra\DataTables\Facades\DataTables;
use Illuminate\Support\Facades\Hash;

class UserController extends Controller
{
    /**
     * Only Authenticated users for "admin" guard 
     * are allowed.
     * 
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth:admin');
    }

    /**
     * Show Admin User Listings.
     * 
     * @return \Illuminate\Http\Response
     */
    public function index(){
        return view('admin.user.index');
    }


    public function getUserListings(){
        $users = User::select('*')->where('user_role', '=', 'subscriber');
        return DataTables::eloquent($users)
            ->addColumn('action','admin.user.action')
            ->rawColumns(['action'])
            ->toJson();
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $userById = User::find($id);
        return view('admin.user.view',compact('userById'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $userById = User::find($id);
        return view('admin.user.view',compact('userById'));
    }

    public function doEdit($id, UpdateUserRequest $updateUserRequest){
        $validated = $updateUserRequest->validated();
        $user = User::find($id);
        $userData = [
            'email' => $validated['email'],
            'first_name' => $validated['first_name'],
            'last_name' => $validated['last_name'],
            'name' => $validated['first_name']. ' ' .$validated['last_name'],
            'user_status' => $validated['user_status']
        ];

        //echo "<pre>"; print_r($userData); echo "</pre>"; die('sfds');

        if($updateUserRequest->has('password')){
            $userData['password'] = Hash::make($validated['password']);
        }

        $user->update($userData);       

        return redirect()
                ->intended(route('admin.user'))
                ->with('status','User '.$validated['email'].' details updated.');
    }
}

resources/views/admin/user/action.blade.php
<div class="text-center">
    <?php /* <a class="btn btn-primary btn-sm" href="javascript:void(0)">
        <i class="fas fa-folder">
        </i>
        View Donations
    </a> */ ?>

    <a class="btn btn-info btn-sm" href="{{ route('admin.user.edit', $id) }}">
        <i class="fas fa-pencil-alt">
        </i>
        Edit
    </a>
    
    <!-- <a data-name="{{ $first_name }} {{ $last_name }}" data-url="{{ route('admin.user.delete', $id)  }}" href="#" class="btn icon-btn btn-sm btn-outline-primary act-delete-user"> <i class="fa fa-trash-alt"></i> </a> -->
</div>

resources/views/admin/user/index.blade.php
@extends('layouts.app')


@section('header')
<!-- DataTables -->
<link rel="stylesheet" href="{{asset('app-assets/admin/plugins/datatables-bs4/css/dataTables.bootstrap4.min.css')}}">
<link rel="stylesheet" href="{{asset('app-assets/admin/plugins/datatables-responsive/css/responsive.bootstrap4.min.css')}}">
@endsection

@section('content')


<!-- Content Wrapper. Contains page content -->
<div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
        <div class="container-fluid">
            <div class="row mb-2">
                <div class="col-sm-6">
                    <h1>User Listings</h1>
                </div>
                <div class="col-sm-6">
                    <ol class="breadcrumb float-sm-right">
                        <li class="breadcrumb-item"><a href="#">Home</a></li>
                        <li class="breadcrumb-item active">User Listings</li>
                    </ol>
                </div>
            </div>
        </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
        <div class="row">
            <div class="col-12">
                <div class="card">
                    
                    <div class="card-body" id="admin-users-list-wrap">
                        <table id="table-manage-users" class="table table-bordered table-striped" data-url="{{ route('admin.getUserListings') }}">
                            <thead>
                                <tr>
                                    <th>ID</th>
                                    <th>Name</th>
                                    <th>Email</th>
                                    <th>Status</th>
                                    <th>Action</th>
                                </tr>
                            </thead>
                            
                            
                        </table>
                    </div>
                    <!-- /.card-body -->
                </div>
                <!-- /.card -->
            </div>
            <!-- /.col -->
        </div>
        <!-- /.row -->
    </section>
    <!-- /.content -->
</div>
<!-- /.content-wrapper -->



@endsection

@section('footer')
<!-- DataTables -->
<script src="{{asset('app-assets/admin/plugins/datatables/jquery.dataTables.min.js')}}"></script>
<script src="{{asset('app-assets/admin/plugins/datatables-bs4/js/dataTables.bootstrap4.min.js')}}"></script>
<script src="{{asset('app-assets/admin/plugins/datatables-responsive/js/dataTables.responsive.min.js')}}"></script>
<script src="{{asset('app-assets/admin/plugins/datatables-responsive/js/responsive.bootstrap4.min.js')}}"></script>
<script src="{{asset('app-assets/admin/pages/user.js')}}"></script>
@endsection

resources/views/admin/user/view.blade.php
@extends('layouts.app')
@section('content')
<!-- Content Wrapper. Contains page content -->
<div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
        <div class="container-fluid">
            <div class="row mb-2">
                <div class="col-sm-6">
                    <h1>User View</h1>
                </div>
                <div class="col-sm-6">
                    <ol class="breadcrumb float-sm-right">
                        <li class="breadcrumb-item"><a href="#">Home</a></li>
                        <li class="breadcrumb-item active">{{ $userById->name }} / Edit</li>
                    </ol>
                </div>
            </div>
        </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
        <div class="row">
            <div class="col-md-12">
                <div class="card card-primary">
                    
                    <div class="card-body">
                        <form method="post" action="{{ route('admin.user.do-edit', $userById->id) }}">
                            {{ csrf_field() }}
                            <div class="form-group">
                                <label for="inputName">First Name</label>
                                <input type="text" name="first_name" id="inputFirstName" class="form-control {{ ( $errors->has('first_name') || $errors->has('invalidUserUpdate') ) ? 'is-invalid' : '' }}" value="{{ old('first_name',$userById->first_name) }}">

                                @if($errors->has('first_name'))
                                <span class="invalid-feedback">
                                    {{ $errors->first('first_name') }}
                                </span>
                                @endif
                            </div>
                            <div class="form-group">
                                <label for="inputName">Last Name</label>
                                <input type="text" name="last_name" id="inputLastName" class="form-control {{ ( $errors->has('last_name') || $errors->has('invalidUserUpdate') ) ? 'is-invalid' : '' }}" value="{{ old('last_name',$userById->last_name) }}">

                                @if($errors->has('last_name'))
                                <span class="invalid-feedback">
                                    {{ $errors->first('last_name') }}
                                </span>
                                @endif
                            </div>
                            <div class="form-group">
                                <label for="inputDescription">Email</label>
                                <input type="text" name="email" id="inputEmail" class="form-control {{ ( $errors->has('email') || $errors->has('invalidUserUpdate') ) ? 'is-invalid' : '' }}" value="{{ old('email',$userById->email) }}" readonly>

                                @if($errors->has('email'))
                                <span class="invalid-feedback">
                                    {{ $errors->first('email') }}
                                </span>
                                @endif
                            </div>
                            <div class="form-group">
                                <label for="inputDescription">New Password</label>
                                <input type="password" name="password" id="inputPassword" class="form-control {{ ( $errors->has('password') || $errors->has('invalidUserUpdate') ) ? 'is-invalid' : '' }}" value="">
                                @if($errors->has('password'))
                                <span class="invalid-feedback">
                                    {{ $errors->first('password') }}
                                </span>
                                @endif
                            </div>
                            <div class="form-group">
                                <label for="inputDescription">Confirm Password</label>
                                <input type="password" name="password_confirmation" id="inputConfirmPassword" class="form-control {{ ( $errors->has('password_confirmation') ) ? 'is-invalid' : '' }}" value="">
                                @if($errors->has('password_confirmation'))
                                <span class="invalid-feedback">
                                    {{ $errors->first('password_confirmation') }}
                                </span>
                                @endif
                            </div>
                            <div class="form-group">
                                <label for="inputStatus">Status</label>
                                <select name="user_status" class="form-control custom-select">
                                    <option selected disabled>Select one</option>
                                    <option {{ old( 'user_status', $userById->user_status ) == 'active' ? 'selected' : '' }} value="active">Active</option>
                                    <option {{ old( 'user_status', $userById->user_status ) == 'inactive' ? 'selected' : '' }} value="inactive">Inactive</option>
                                </select>
                            </div>

                            <div class="col-12">
                                <a href="{{ route('admin.user') }}" class="btn btn-secondary">Cancel</a>
                                <input type="submit" value="Update" class="btn btn-success float-right">
                            </div>
                        </form>
                    </div>
                    <!-- /.card-body -->
                </div>
                <!-- /.card -->
            </div>

        </div>

    </section>
    <!-- /.content -->
</div>
<!-- /.content-wrapper -->
@endsection